diff -up ./src/netstatus-dialog.c.clean ./src/netstatus-dialog.c
--- ./src/netstatus-dialog.c.clean	2009-10-20 08:28:14.750343205 +0100
+++ ./src/netstatus-dialog.c	2009-10-13 09:46:14.868292341 +0100
@@ -1,6 +1,6 @@
 /* vim: set sw=2 ts=2 sts=2 et: */
 /*
- * Copyright (C) 2003 Sun Microsystems, Inc.
+ * Copyright (C) 2003-2009 Sun Microsystems, Inc.
  * Copyright (C) 2004 Red Hat Inc.
  *
  * This program is free software; you can redistribute it and/or
@@ -36,6 +36,27 @@
 #define NETWORK_CONFIG_TOOL_DIR "/apps/netstatus_applet"
 #define NETWORK_CONFIG_TOOL_KEY NETWORK_CONFIG_TOOL_DIR "/config_tool"
 
+static const gchar * IFRESTART_TAB_LABLE_NAME        = "restart_tab_label";
+static const gchar * IFRESTART_TAB_BUTTON_NAME       = "restart_button";
+static const gchar * IFRESTART_TAB_BUTTON_LABEL_NAME = "restart_button_label";
+static const gchar * IFRESTART_TAB_BUTTON_IMAGE_NAME = "restart_button_image";
+static const gchar * IFRESTART_TAB_HBOX_NAME         = "restart_hbox";
+
+static const gchar * IFRESTART_TAB_BUTTON_LABEL_RESTART = "_Restart";
+static const gchar * IFRESTART_TAB_BUTTON_LABEL_STOP    = "_Stop";
+
+static const gchar * IFRESTART_WINDOW_TITLE_FORMAT = "%s: %s";
+static const gchar * IFRESTART_WINDOW_TITLE = "Restartin Connection";
+
+static const gchar * IFRESTART_PROGRESS_FORMAT = "<b>%s</b>: <i>%s</i>";
+static const gchar * IFRESTART_PROGRESS = "Progress";
+static const gchar * IFRESTART_PROGRESS_BEGIN = "Click Restart to begin";
+static const gchar * IFRESTART_PROGRESS_RESTARTING = "Restarting...";
+static const gchar * IFRESTART_PROGRESS_COMPLETE = "Complete";
+static const gchar * IFRESTART_PROGRESS_FAILED = "Failed, click here for details";
+static const gchar * IFRESTART_WARNING = "Warning";
+static const gchar * IFRESTART_WARNING_NOLO = "Cannot restart this connection";
+
 static const char *network_config_tools[] = {
   "network-admin --configure %i",
   "redhat-config-network",
@@ -64,6 +85,11 @@ typedef struct
   GtkWidget      *signal_strength_frame;
   GtkWidget      *signal_strength_bar;
   GtkWidget      *signal_strength_label;
+  GtkWidget      *essid_value_label;
+  GtkWidget      *bssid_value_label;
+  GtkWidget      *bss_mode_value_label;
+  GtkWidget      *security_value_label;
+  GtkWidget      *auth_mode_value_label;
   GtkWidget      *configure_button;
 
   GtkWidget      *inet4_frame;
@@ -81,6 +107,13 @@ typedef struct
   GtkWidget      *dev_type;
   GtkWidget      *dev_addr;
 
+  GtkWidget      *track_active_interface_cbox;
+
+  GtkWidget      *restart_button;
+  GtkWidget      *restart_button_image;
+  GtkWidget      *restart_button_label;
+  GtkWidget      *restart_progress_expander;
+
   guint           iface_list_monitor;
   int             n_ifaces;
 } NetstatusDialogData;
@@ -184,6 +217,11 @@ netstatus_dialog_update_signal_strength 
     {
       int   signal_strength;
       char *str;
+      const char *essid;
+      const char *bssid;
+      const char *bss_mode;
+      const char *auth_mode;
+      const char *security;
 
       gtk_widget_show (data->signal_strength_frame);
 
@@ -195,6 +233,18 @@ netstatus_dialog_update_signal_strength 
       str = g_strdup_printf ("%d%%\n", signal_strength);
       gtk_label_set_text (GTK_LABEL (data->signal_strength_label), str);
       g_free (str);
+
+      essid = netstatus_iface_get_essid (data->iface);
+      bssid = netstatus_iface_get_bssid (data->iface);
+      bss_mode = netstatus_iface_get_bss_mode (data->iface);
+      security = netstatus_iface_get_security (data->iface);
+      auth_mode = netstatus_iface_get_auth_mode (data->iface);
+
+      gtk_label_set_text (GTK_LABEL (data->essid_value_label), essid?essid:"" );
+      gtk_label_set_text (GTK_LABEL (data->bssid_value_label), bssid?bssid:"" );
+      gtk_label_set_text (GTK_LABEL (data->bss_mode_value_label), bss_mode?bss_mode:"" );
+      gtk_label_set_text (GTK_LABEL (data->auth_mode_value_label), auth_mode?auth_mode:"" );
+      gtk_label_set_text (GTK_LABEL (data->security_value_label), security?security:"" );
     }
   else
     {
@@ -313,6 +363,105 @@ netstatus_dialog_update_device_support (
 }
 
 static void
+netstatus_dialog_set_track_active_interface(NetstatusDialogData *data,
+				                            GtkToggleButton     *toggle)
+{
+    gboolean track_active = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(data->track_active_interface_cbox));
+
+    netstatus_iface_set_track_active_interface (data->iface, track_active );
+}
+
+
+static void
+netstatus_dialog_update_track_active_interface (NetstatusDialogData *data)
+{
+  GtkWidget *  widget;
+  gboolean     track_active = FALSE;
+
+  if ( data->track_active_interface_cbox == NULL ) 
+      return;
+
+  track_active = netstatus_iface_get_track_active_interface( data->iface );
+
+  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(data->track_active_interface_cbox), track_active );
+
+  gtk_widget_set_sensitive(GTK_WIDGET(data->name), !track_active );
+
+}
+
+static gboolean
+netstatus_dialog_ask_question(NetstatusDialogData *data, const char* message, const char* question )
+{
+  GtkWidget *dialog;
+  gint       result;
+  gboolean   ret_val = FALSE;
+
+  dialog = gtk_message_dialog_new (GTK_WINDOW (data->dialog),
+				   GTK_DIALOG_MODAL | GTK_DIALOG_DESTROY_WITH_PARENT,
+				   GTK_MESSAGE_QUESTION,
+				   GTK_BUTTONS_YES_NO,
+                   message );
+
+  if (question) {
+      gtk_message_dialog_format_secondary_text( dialog, question );
+  }
+
+  result = gtk_dialog_run (GTK_DIALOG (dialog));
+
+  switch (result) {
+    case GTK_RESPONSE_YES:
+        ret_val = TRUE;
+        break;
+    default:
+        break;
+  }
+
+  gtk_widget_destroy (dialog);
+
+  return( ret_val );
+}
+
+static void
+netstatus_dialog_update_restart_button (NetstatusDialogData *data)
+{
+  GtkWidget *  widget;
+  gchar *      string;
+  const char * ifname;
+
+  if (data->restart_button == NULL)
+    return;
+
+  /* Disable restart button for nothing and loopback interface */
+  ifname = netstatus_iface_get_name (data->iface);
+  if ((ifname != NULL) && (strcmp (ifname, "lo")))
+    {
+      gtk_widget_set_sensitive (data->restart_button, TRUE);
+
+      /* Set "Press button to restart" progress message */
+      string = g_strdup_printf (IFRESTART_PROGRESS_FORMAT, 
+        _(IFRESTART_PROGRESS), _(IFRESTART_PROGRESS_BEGIN));
+    }
+  else
+    {
+      gtk_widget_set_sensitive (data->restart_button, FALSE);
+
+      /* Set "Cannot restart this connection" progress message */
+      string = g_strdup_printf (IFRESTART_PROGRESS_FORMAT, 
+        _(IFRESTART_WARNING), _(IFRESTART_WARNING_NOLO));
+    }
+    gtk_expander_set_label (
+      GTK_EXPANDER (data->restart_progress_expander), string);
+    g_free (string);
+
+    /* Clean up the output of the last restart */
+    widget = gtk_bin_get_child (GTK_BIN (data->restart_progress_expander));
+    if (widget != NULL)
+      {
+        gtk_label_set_text (GTK_LABEL (widget), "");
+      }
+}
+
+static void
 netstatus_dialog_iface_state_changed (NetstatusIface      *iface,
 				      GParamSpec          *pspec,
 				      NetstatusDialogData *data)
@@ -339,12 +488,21 @@ netstatus_dialog_iface_signal_strength_c
 }
 
 static void
+netstatus_dialog_iface_track_active_interface_changed(NetstatusIface      *iface,
+				     GParamSpec          *pspec,
+				     NetstatusDialogData *data)
+{
+    netstatus_dialog_update_track_active_interface( data );
+}
+
+static void
 netstatus_dialog_iface_name_changed (NetstatusIface      *iface,
 				     GParamSpec          *pspec,
 				     NetstatusDialogData *data)
 {
   netstatus_dialog_update_name (data);
   netstatus_dialog_update_signal_strength (data);
+  netstatus_dialog_update_restart_button (data);
 }
 
 static void
@@ -364,6 +522,136 @@ netstatus_dialog_set_iface_name (Netstat
 }
 
 static void
+netstatus_dialog_restart_state_changed (
+  NetstatusIface *iface, NetstatusDialogData *data)
+{
+  GtkWidget * widget;
+  gchar *     string;
+
+  g_return_if_fail (data != NULL);
+  g_return_if_fail (data->iface != NULL);
+
+  if (netstatus_iface_restart_inprogress (data->iface))
+    {
+      /* The restart is in progress */
+      const char * ifname;
+
+      /* Save the current network interface name */
+      ifname = netstatus_iface_get_name (data->iface);
+      g_return_if_fail (ifname != NULL);
+
+      /* Disable network interface change */
+      gtk_widget_set_sensitive (data->name, FALSE);
+
+      /* Set the restart button to Stop */
+      gtk_image_set_from_stock (GTK_IMAGE (data->restart_button_image), 
+        GTK_STOCK_STOP, GTK_ICON_SIZE_BUTTON);
+      gtk_label_set_text_with_mnemonic (GTK_LABEL (data->restart_button_label), 
+        _(IFRESTART_TAB_BUTTON_LABEL_STOP));
+
+      /* Set dialog window title */
+      string = g_strdup_printf (IFRESTART_WINDOW_TITLE_FORMAT, 
+        _(IFRESTART_WINDOW_TITLE), ifname);
+      gtk_window_set_title (GTK_WINDOW (data->dialog), string);
+      g_free (string);
+
+      /* Set the progress message */
+      string = g_strdup_printf (IFRESTART_PROGRESS_FORMAT, 
+        _(IFRESTART_PROGRESS), _(IFRESTART_PROGRESS_RESTARTING));
+      gtk_expander_set_label (
+        GTK_EXPANDER (data->restart_progress_expander), string);
+      g_free (string);
+
+      /* Clean up the output of the script */
+      widget = gtk_bin_get_child (GTK_BIN (data->restart_progress_expander));
+      if (widget != NULL)
+        {
+          gtk_label_set_text (GTK_LABEL (widget), "");
+        }
+    }
+  else
+    {
+      /* The restart is completed */
+      gint state;
+
+      /* Set the restart button to Restart */
+      gtk_image_set_from_stock (GTK_IMAGE (data->restart_button_image), 
+        GTK_STOCK_REFRESH, GTK_ICON_SIZE_BUTTON);
+      gtk_label_set_text_with_mnemonic (GTK_LABEL (data->restart_button_label), 
+        _(IFRESTART_TAB_BUTTON_LABEL_RESTART));
+
+      /* Enable network interface change */
+      gtk_widget_set_sensitive (data->name, TRUE);
+
+      /* Restore dialog window title */
+      netstatus_dialog_update_name (data);
+
+      /* Set the progress message */
+      state = netstatus_iface_restart_get_status (data->iface);
+      if (state == 0)
+        {
+          /* Restart has been completed successfully */
+          string = g_strdup_printf (IFRESTART_PROGRESS_FORMAT, 
+            _(IFRESTART_PROGRESS), _(IFRESTART_PROGRESS_COMPLETE));
+        }
+      else if (state > 0)
+        {
+          /* Restart has failed */
+          string = g_strdup_printf (IFRESTART_PROGRESS_FORMAT, 
+            _(IFRESTART_PROGRESS), _(IFRESTART_PROGRESS_FAILED));
+        }
+      else
+        {
+          /* No restart has been completed or started yet */
+          string = g_strdup_printf (IFRESTART_PROGRESS_FORMAT, 
+            _(IFRESTART_PROGRESS), _(IFRESTART_PROGRESS_BEGIN));
+        }
+      gtk_expander_set_label (
+        GTK_EXPANDER (data->restart_progress_expander), string);
+      g_free (string);
+
+      /* Set the output of the script */
+      widget = gtk_bin_get_child (GTK_BIN (data->restart_progress_expander));
+      if (widget != NULL)
+        {
+          string = netstatus_iface_restart_get_output (data->iface);
+          switch (state)
+            {
+              case 9:     /* canceled by "Stop" button */
+              case 3072:  /* canceled by root password dialog */
+                string = _("Connection restart has been stopped.");
+                break;
+
+              case 19:    /* there is no ifrestart script */
+                string = _("Cannot find ifrestart script.");
+                break;
+
+              default:
+                break;
+            }
+          gtk_label_set_text (GTK_LABEL (widget), string);
+        }
+    }
+}
+
+static void
+netstatus_dialog_restart (GtkWidget *button, NetstatusDialogData *data)
+{
+  g_return_if_fail (data != NULL);
+
+  if (netstatus_iface_restart_inprogress (data->iface))
+    {
+      /* Interrupt the network interface restart */
+      netstatus_iface_restart_interrupt (data->iface);
+    }
+  else
+    {
+      /* Spawn the network interface restart */
+      netstatus_iface_restart (data->iface);
+    }
+}
+
+static void
 netstatus_dialog_response (GtkWidget *dialog,
 			   int        response)
 {
@@ -441,7 +729,11 @@ netstatus_dialog_destroy (GtkWidget *dia
   data->iface_list_monitor = 0;
 
   if (data->iface)
-    g_object_unref (data->iface);
+    {
+      g_signal_handlers_disconnect_matched (
+        data->iface, G_SIGNAL_MATCH_DATA, 0, 0, NULL, NULL, (gpointer) data);
+      g_object_unref (data->iface);
+    }
   data->iface = NULL;
 
   g_free (data);
@@ -603,6 +895,26 @@ netstatus_dialog_setup_configure_button 
 }
 
 static void
+netstatus_dialog_setup_track_active_interface (NetstatusDialogData *data,
+				                                       GtkBuilder *builder)
+{
+  GtkWidget *cbox;
+  
+  cbox = GTK_WIDGET (gtk_builder_get_object (builder, "track_active_interface"));
+
+  gtk_widget_show (cbox);
+
+  data->track_active_interface_cbox = cbox;
+
+  netstatus_dialog_update_track_active_interface(data);
+
+  g_signal_connect_swapped(GTK_TOGGLE_BUTTON (data->track_active_interface_cbox), "toggled",
+			    G_CALLBACK (netstatus_dialog_set_track_active_interface),
+			    data);
+
+}
+
+static void
 netstatus_dialog_setup_connection (NetstatusDialogData *data,
                                   GtkBuilder *builder)
 {
@@ -652,6 +964,11 @@ netstatus_dialog_setup_signal_strength_d
   data->signal_strength_frame = GTK_WIDGET (gtk_builder_get_object (builder, "signal_strength_frame"));
   data->signal_strength_bar   = GTK_WIDGET (gtk_builder_get_object (builder, "signal_strength_bar"));
   data->signal_strength_label = GTK_WIDGET (gtk_builder_get_object (builder, "signal_strength_label"));
+  data->essid_value_label     = GTK_WIDGET (gtk_builder_get_object (builder, "essid_value_label"));
+  data->bssid_value_label     = GTK_WIDGET (gtk_builder_get_object (builder, "bssid_value_label"));
+  data->bss_mode_value_label  = GTK_WIDGET (gtk_builder_get_object (builder, "bss_mode_value_label"));
+  data->auth_mode_value_label = GTK_WIDGET (gtk_builder_get_object (builder, "auth_mode_value_label"));
+  data->security_value_label  = GTK_WIDGET (gtk_builder_get_object (builder, "security_value_label"));
 
   netstatus_dialog_update_signal_strength (data);
 }
@@ -720,6 +1037,88 @@ netstatus_dialog_iface_list_monitor (Net
   return TRUE;
 }
 
+static void
+netstatus_dialog_setup_restart_tab (NetstatusDialogData *data, GtkBuilder *builder)
+{
+  GtkWidget * widget;
+
+  g_return_if_fail (data != NULL);
+  g_return_if_fail (builder != NULL);
+
+  /* Network interface restart tab */
+  if (netstatus_iface_restart_available (data->iface))
+    {
+      /* Restart button */
+      data->restart_button = GTK_WIDGET (
+        gtk_builder_get_object (builder, IFRESTART_TAB_BUTTON_NAME));
+      if (data->restart_button != NULL)
+        {
+          /* Button image */
+          data->restart_button_image = GTK_WIDGET (
+            gtk_builder_get_object (builder, IFRESTART_TAB_BUTTON_IMAGE_NAME));
+          /* Button label */
+          data->restart_button_label = GTK_WIDGET (
+            gtk_builder_get_object (builder, IFRESTART_TAB_BUTTON_LABEL_NAME));
+          /* Clicked signal handler */
+          g_signal_connect (G_OBJECT (data->restart_button), "clicked", 
+            G_CALLBACK (netstatus_dialog_restart), (gpointer) data);
+        }
+      /* Add progress expander */
+      widget = GTK_WIDGET (
+            gtk_builder_get_object (builder, IFRESTART_TAB_HBOX_NAME));
+      if (widget != NULL)
+        {
+          gtk_box_set_spacing (GTK_BOX (widget), 2);
+          data->restart_progress_expander = gtk_expander_new ("");
+          gtk_expander_set_use_markup (
+            GTK_EXPANDER (data->restart_progress_expander), TRUE);
+          gtk_box_pack_start (GTK_BOX (widget), 
+            data->restart_progress_expander, FALSE, FALSE, 0);
+          gtk_box_reorder_child (GTK_BOX (widget),
+            data->restart_progress_expander, 0);
+          widget = gtk_label_new ("");
+          gtk_label_set_selectable (GTK_LABEL (widget), TRUE);
+          gtk_container_add (
+            GTK_CONTAINER (data->restart_progress_expander), widget);
+          gtk_widget_show_all (data->restart_progress_expander);
+        }
+
+      netstatus_dialog_restart_state_changed (data->iface, data);
+      netstatus_dialog_update_restart_button (data);
+
+      g_signal_connect (
+        data->iface, NETSTATUS_IFACE_SIGNAL_RESTART_STATE,
+        G_CALLBACK (netstatus_dialog_restart_state_changed), data);
+    }
+  else
+    {
+      GtkNotebook * notebook;
+      const gchar * name;
+      gint          idx;
+
+      /* Remove the restart tab */
+      notebook = GTK_NOTEBOOK (
+        GTK_WIDGET (gtk_builder_get_object (builder, "notebook1")));
+      if (notebook != NULL)
+        {
+          for (idx = 0; idx < gtk_notebook_get_n_pages (notebook); idx++)
+            {
+              widget = gtk_notebook_get_nth_page (notebook, idx);
+              widget = gtk_notebook_get_tab_label (notebook, widget);
+              if (widget != NULL)
+                {
+                  name   = gtk_widget_get_name (widget);
+                  if (!strcmp (name, IFRESTART_TAB_LABLE_NAME))
+                    {
+                      gtk_notebook_remove_page (notebook, idx);
+                      break;
+                    }
+                }
+            }
+        }
+    }
+}
+
 GtkWidget *
 netstatus_dialog_new (NetstatusIface *iface)
 {
@@ -743,7 +1142,7 @@ netstatus_dialog_new (NetstatusIface *if
   data->dialog = GTK_WIDGET (gtk_builder_get_object (builder, "network_status_dialog"));
   g_object_set_data (G_OBJECT (data->dialog), "netstatus-dialog-data", data);
 
-  gtk_window_set_icon_name(GTK_WINDOW (data->dialog), "gnome-netstatus-tx");	
+  gtk_window_set_icon_name(GTK_WINDOW (data->dialog), "network-transmit");	
 
   data->iface = g_object_ref (iface);
   netstatus_connect_signal_while_alive (data->iface,
@@ -771,11 +1170,23 @@ netstatus_dialog_new (NetstatusIface *if
 					data->dialog);
 
   netstatus_connect_signal_while_alive (data->iface,
+					"notify::connected",
+					G_CALLBACK (netstatus_dialog_iface_signal_strength_changed),
+					data,
+					data->dialog);
+
+  netstatus_connect_signal_while_alive (data->iface,
 					"notify::signal-strength",
 					G_CALLBACK (netstatus_dialog_iface_signal_strength_changed),
 					data,
 					data->dialog);
 
+  netstatus_connect_signal_while_alive (data->iface,
+					"notify::track-active-inteface",
+					G_CALLBACK (netstatus_dialog_iface_track_active_interface_changed),
+					data,
+					data->dialog);
+  
   g_signal_connect (data->dialog, "response",
 		    G_CALLBACK (netstatus_dialog_response), NULL);
 
@@ -783,11 +1194,13 @@ netstatus_dialog_new (NetstatusIface *if
 		    G_CALLBACK (netstatus_dialog_destroy), NULL);
 
   netstatus_dialog_setup_connection (data, builder);
+  netstatus_dialog_setup_track_active_interface (data, builder);
   netstatus_dialog_setup_activity (data, builder);
   netstatus_dialog_setup_signal_strength_details (data, builder);
   netstatus_dialog_setup_inet4_support (data, builder);
   netstatus_dialog_setup_device_support (data, builder);
   netstatus_dialog_setup_configure_button (data, builder);
+  netstatus_dialog_setup_restart_tab (data, builder);
 
   data->iface_list_monitor = g_timeout_add (2 * 1000,
 					    (GSourceFunc) netstatus_dialog_iface_list_monitor,

